<template>
  <div class="app">
      <div class="app-title">
        ON - BOARD
      </div>
    <div class="main-container">
      <!-- APP ROUTER AND FOOTER CONTAINER -->
      <div class="content">
        <router-view class="router-container" ></router-view>
        <div class="footer-container">
          @ 2021 All Rights Reserved 
          <router-link to="/about"> ∙ About ∙ </router-link>
          <a href="http://tiago-sales.me" target="_blank">developed by Tiago Sales -</a>
          <a href="https://gitlab.com/antunesales.developer/who-is-on-board/-/tree/develop/who-is-on-board" target="_blank"> GIT</a>
        </div>
      </div>
      <!-- APP SIDE NAV COINTAINER -->
      <div class="nav" @mouseenter="handleShowActionsButton()"
                    @mouseleave="handleShowActionsButton()">    
        <div class="nav-fixed-container" v-if="showActionsButton">
          <!-- SIDE NAV - HOME BUTTON -->
          <div class="global-actions-buttons">
            <router-link to="/" title="Go Home" class="router-link-class">
              <i class="fas fa-house-user"></i>
            </router-link>
          </div>
          <!-- SIDE NAV - MONSTER TYPE CONTAINER -->
          <div @mouseenter="handleTypeSelector()"
               @mouseleave="handleTypeSelector()"
             class="global-actions-buttons type-button">
                <i class="fas fa-th-large" :class="handleTypeSelectorButtonClass()"></i>
              <div class="monster-type-list-container" v-show="typeSelectorArea">
                <ul class="monster-type-list">
                  <li class="monster-type" @click="resetMonsterListbyType()">Show All</li>
                  <li @click="setMonstersListByType(type)"
                      v-for="type in monstersTypeList" 
                      :key="type.id">
                    <router-link to="/" class="monster-type">
                      {{type}}
                    </router-link>
                  </li>
                </ul>
              </div>
            </div>
          <!-- SIDE NAV - PICK RANDOM MONSTER BUTTON -->         
          <div class="global-actions-buttons" title="Random Pick" @click="pickRandomMonster(randomPick)">
            <router-link :to="randomPick" class="router-link-class">
              <i class="fas fa-dice"></i>
            </router-link>
          </div>
        </div>
        <!-- NAV BUTTON ON SCREEN LOWER THAN 1024 -->
        <div class="menu-actions-button" 
             v-show="showActionsButtonMenu">
          <i class="fas fa-crosshairs"></i>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
  import Vue from 'vue'
  import MonstersListService from "@/services/MonstersListService";
  import Monster from "@/types/Monster";
  import EventBus from './EventBus'

   const TYPE_LIST_ON_ACTIVE = 'type-list-on-active';

  export default Vue.extend({
    data() {
      return {
        monsters: [] as Monster[],
        randomPick: {},
        monstersTypeList: [{}],
        typeSelectorArea: false,
        selectedType: '',
        showActionsButtonMenu: false,
        showActionsButton: false,
        windowWidth: 0
      }
    },
    methods: {
      // GET MONSTERS TYPE LIST AND RETURNS ALL TYPES EXCLUDING REPEATED
      getMonstersTypeLsit() {
        const monstersList: any[] = []
      MonstersListService.getAll()
        .then((response) => {
          this.monsters = response.data.results.map((index: any) => index.index)
          for(let i = 0; i < this.monsters.length; i++) {
            MonstersListService.get(this.monsters[i])
            .then((monstersResults) => {
              if(monstersList.indexOf(monstersResults.data.type) === -1) {
                monstersList.push(monstersResults.data.type)
              }
            })
          }
            this.monstersTypeList = monstersList
        })     
      },
      // SET MONSTERS LIST BY SELECTED TYPE
      setMonstersListByType(selectedType: any) {
        this.selectedType = selectedType
        EventBus.$emit('filterListByType', this.selectedType)
      },
      // RESET MONSTERS LIST SHOWING ALL MONSTERSAGAIN
      resetMonsterListbyType() {
        this.selectedType = ''
        EventBus.$emit('filterListByType', this.selectedType)
      },
      // SHOW OR HIDE THE MONSTERS TYPE LIST ON TYPE BUTTON HOVER
      handleTypeSelector(){
        this.typeSelectorArea = !this.typeSelectorArea
      },
      // SETS TYPE BUTTON CLASS WHEN MONSTERS TYPE LIST IS TRUE
      handleTypeSelectorButtonClass() {
        if(this.typeSelectorArea == true) {
          return TYPE_LIST_ON_ACTIVE
        }
      },
      // GETS ALL MONSTERS AND RETURN A RANDOM MONSTER INDEX 
      getAllMonsters() {
          MonstersListService.getAll()
          .then((response) => {
            this.monsters = response.data.results.map((index: any) => index.index)
            this.randomPick = this.monsters[Math.floor(Math.random() * this.monsters.length)];
        })
      },
      // SETS A RANDOM MONSTER WHEN RANDOM BUTTON IS CLICKED, THE RELOAD ACTION IS TO FORCE A RANDOM PICK WHEN IN SHOWING THE MONSTER DETAIL PAGE
      pickRandomMonster(monster: Monster) {
        MonstersListService.monsterSelected(monster)
          .then(response => {
             this.randomPick = response.data.index
            })
        window.location.reload();
      },
      // HIDE/SHOW SIDE NAV, SHOW/HIDE ACTIONS BUTTON WHEN SCREEN RESOLUTION LOWER THEN 1024
      handleShowActionsButtonMenu() {
        this.windowWidth = window.innerWidth
        if (this.windowWidth < 1024) {
          this.showActionsButton = false
          this.showActionsButtonMenu = true
        } else {
          this.showActionsButton = true
          this.showActionsButtonMenu = false
        }
      },
      // SHOW/HIDE ON HOVER ACTIONS CONTAINER
      handleShowActionsButton() {
        this.windowWidth = window.innerWidth
        if (this.windowWidth < 1024) {
        this.showActionsButton = !this.showActionsButton
        }
      },
    },
    mounted() {
      this.getAllMonsters()
      this.getMonstersTypeLsit()
      this.handleShowActionsButtonMenu()
      window.addEventListener('resize', () => {
        this.handleShowActionsButtonMenu()
      })
    }
  })
</script>

<style>
.app {
  position: absolute;
  display: flex;
  flex-direction: column;
  left: 0;
  top: 0;
  bottom: 0;
  width: 100%;
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
}

.app-title {
  position: relative;
  padding: 0.5em;
  height: 1.25em;
  background-color: #000000;
  color: #ffff;
  font-size: 4em;
  font-weight: bold;
  letter-spacing: 1em;
  text-shadow: 5px 2.5px 5px #7a0000;
  user-select: none;
  z-index: 1;
}

.main-container { 
  position: relative;
  display: flex;
  padding: 0;
  margin: 0;
  
  background-color: #ffffff;
  background-image: url("https://www.transparenttextures.com/patterns/gplay.png");
}

.content {
  display: flex;
  flex-direction: column;
  flex-basis: 0;
  flex-grow: 999;
}


.nav {
  flex-basis: 20em;
  flex-grow: 0;
  margin-right: 1em;
  max-width: 4em;
  background-color: #ffffff80;
}

.nav-fixed-container {
  position: fixed;
  margin-right: 0.50em;
  bottom: 0;
  background-color: #ffffff80;
  border-left: 0.1em solid #000000;
  font-size: 2em;
  z-index: 1;
}

 .global-actions-buttons {
  display: flex;
  flex-direction: column;
  color: #7a0000;
  border: 1px solid #ffffff00;
  border-radius: 0.3em;
  cursor: pointer;
}

.router-link-class, .type-button {
  padding: 0.5em;
}

.global-actions-buttons:hover {
  background-color: #00000033;
  border: 1px solid #ffff;
  box-shadow: 0.1em 0.1em 0.1em 0.01em #00000033;
}

.router-link-class {
  color: #7a0000;
}

.router-link-class:hover {
  color: #000000;
}

a.router-link-exact-active {
  color: #000000;
}

.monster-type-list-container {
  position: absolute;
  top: -1.5em;
  right: 2.30em;
}

.monster-type-list {
  padding: 0.25em;
  margin: 0;
  list-style-type: none;
  background-color: #f5f5f5;
  border: 1px solid #ffff;
  border-radius: 0.3em;
  font-size: 0.6em;
}

.monster-type {
  display: flex;
  padding: 0em;
  padding-left: 0.5em;
  padding-right: 0.5em;
  margin-top: 0.25em;
  margin-bottom: 0.25em;
  text-transform: capitalize;
  text-decoration: none;
  color: #000000;
}

.monster-type:hover{
  background-color: #ffffff;
  color: #7a0000;
}

.type-list-on-active {
  color: #000000;
}

.router-container {
  min-height: 70em;
}

.footer-container {
  position: relative;
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 0.5em;
  height: 5em;
  color: #7a0000;
  font-style: italic;
  font-weight: bold;
  letter-spacing: 0.15em;
}

.footer-container a {
  text-decoration: none;
  color: #7a0000;
}

/*Styling ScrollBar*/

::-webkit-scrollbar {
  width: 0.4em;
}

::-webkit-scrollbar-track {
  background: #00000027; 
}

::-webkit-scrollbar-track:hover {
  background: #00000038;
}

::-webkit-scrollbar-thumb {
  background: #000000; 
}

::-webkit-scrollbar-thumb:hover {
    background: #000000; 
}

/* DYNAMIC STYLE AREA */

@media only screen and  (max-width: 1024px) {
  .app {
    bottom: 0;
  }

  .app-title {
    padding: 0.9em;
    font-size: 2.5em;
  }

  .router-container {
    padding-left: 0.5em;
    padding-right: 0.5em;
  }

  .nav {
    position: fixed;
    display: flex;
    flex-direction: column;
    align-items: center;
    padding: 0em;
    right: 1.5em;
    bottom: 3em;
    background-color: #ffffff00;
    border: none;
  }

  .menu-actions-button {
    position: relative;
    display: flex;
    justify-content: center;
    align-items: center;
    padding: 0.25em;
    margin: 0;
    margin-top: 0.25em;
    background-color: #7a0000;
    border-radius: 100%;
    border: solid 0.1em #ffffff;
    color: #ffffff;
    font-size: 3em;
  }

  .nav-fixed-container {
    position: relative;
    background-color: #f5f5f5;
    top: 0em;
    border-radius: 0.5m;
    font-size: 2em;
  }

  .global-actions-buttons{
    border: none;
  }

  .global-actions-buttons:hover{
    background-color: #ffffff00;
    border: none;
    box-shadow: none;
  }

  .global-actions-buttons i:hover{
    color: black;
  }

  .monster-type-list-container {
    top: -1em;
    right: 1.75em;
    font-size: 1.25em;
  }

  .footer-container {
    padding-bottom: 3em;
    font-size: 1.25em;
  }

}

</style>
